VERSION 5.00
Begin VB.Form ACS_Atlas 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "ACS Atlas"
   ClientHeight    =   3255
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4005
   Icon            =   "ACS_Atlas.frx":0000
   LinkTopic       =   "ACS_Atlas"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3255
   ScaleWidth      =   4005
   Begin VB.CommandButton cmdLookup 
      Caption         =   "Transfer above data"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   930
      TabIndex        =   18
      Top             =   2820
      Width           =   3000
   End
   Begin VB.ComboBox ComboCity 
      Height          =   315
      Left            =   930
      TabIndex        =   1
      Top             =   360
      Width           =   3000
   End
   Begin VB.ComboBox ComboState_Country 
      Height          =   315
      Left            =   930
      TabIndex        =   0
      Top             =   30
      Width           =   3000
   End
   Begin VB.TextBox ACSAtlas1 
      Height          =   285
      Index           =   6
      Left            =   930
      TabIndex        =   8
      Top             =   2490
      Width           =   3000
   End
   Begin VB.TextBox ACSAtlas1 
      Height          =   285
      Index           =   5
      Left            =   930
      TabIndex        =   7
      Top             =   2190
      Width           =   3000
   End
   Begin VB.TextBox ACSAtlas1 
      Height          =   285
      Index           =   4
      Left            =   930
      TabIndex        =   6
      Top             =   1890
      Width           =   3000
   End
   Begin VB.TextBox ACSAtlas1 
      Height          =   285
      Index           =   3
      Left            =   930
      TabIndex        =   5
      Top             =   1590
      Width           =   3000
   End
   Begin VB.TextBox ACSAtlas1 
      Height          =   285
      Index           =   2
      Left            =   930
      TabIndex        =   4
      Top             =   1290
      Width           =   3000
   End
   Begin VB.TextBox ACSAtlas1 
      Height          =   285
      Index           =   1
      Left            =   930
      TabIndex        =   3
      Top             =   990
      Width           =   3000
   End
   Begin VB.TextBox ACSAtlas1 
      Height          =   285
      Index           =   0
      Left            =   930
      TabIndex        =   2
      Top             =   690
      Width           =   3000
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Time zone"
      Height          =   240
      Index           =   8
      Left            =   60
      TabIndex        =   17
      Top             =   2520
      Width           =   825
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Type"
      Height          =   240
      Index           =   7
      Left            =   60
      TabIndex        =   16
      Top             =   2220
      Width           =   825
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Time"
      Height          =   240
      Index           =   6
      Left            =   60
      TabIndex        =   15
      Top             =   1920
      Width           =   825
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Date"
      Height          =   240
      Index           =   5
      Left            =   60
      TabIndex        =   14
      Top             =   1620
      Width           =   825
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Latitude"
      Height          =   240
      Index           =   4
      Left            =   60
      TabIndex        =   13
      Top             =   1320
      Width           =   825
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Longitude"
      Height          =   240
      Index           =   3
      Left            =   60
      TabIndex        =   12
      Top             =   1020
      Width           =   825
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "County"
      Height          =   240
      Index           =   2
      Left            =   60
      TabIndex        =   11
      Top             =   720
      Width           =   825
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "City"
      Height          =   240
      Index           =   1
      Left            =   60
      TabIndex        =   10
      Top             =   420
      Width           =   825
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "State"
      Height          =   240
      Index           =   0
      Left            =   60
      TabIndex        =   9
      Top             =   90
      Width           =   825
   End
End
Attribute VB_Name = "ACS_Atlas"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim crlf As String
Dim Longitude As String, Latitude As String

Dim country_count&, city_count&, county_count&
Dim country_name As String * 61, country_abbrev As String * 7, city_name As String * 61, county_name  As String * 61
Dim countries() As String, abbrevs() As String, cities() As String, counties() As String

Dim date_of_change As Double, date_of_change_index As Long

Dim index_into_atlas_countries&
Dim index_into_atlas_cities&

'The values in datafields() are:
'0 county number + duplicate flag * 1000
'1 latitude in seconds of arc.
'2 longitude in seconds of arc.
'3 Type table
'4 Zone table
'5 state or country number
Dim datafields() As Long

Dim xnext() As Long, Ret&

Const WM_SETREDRAW = &HB


Public Sub Display_associated_data_for_this_city(city_idx%)
'take this city's index and display all its attributes
    Dim LongDeg As Integer, LongMin As Integer, LatDeg As Integer, LatMin As Integer
    Dim e_w As String, n_s As String
    Dim M As Integer, D As Integer, Y As Integer, H As Integer, min As Integer
    Dim temp As Long, z%, z1%, z2%
    Dim tzout() As Integer, ttout() As Integer, flagout() As Integer
    Dim zonename As String * 7, time_type$
    Dim t$, t1$, X!, adj_x!

'set up all the needed arrays
    ReDim datafields(5), xnext(0), tzout(0), ttout(0), flagout(0)

'get data associated with this city
    Ret& = GetDataFields(city_idx%, datafields(0))
    If Ret& = -1 Then
        Call Clear_output_data_due_to_error
        MsgBox "State/country not set", vbExclamation, "Error"
        Exit Sub
    ElseIf Ret& = -2 Then
        Call Clear_output_data_due_to_error
        MsgBox "City index number out of range", vbExclamation, "Error"
        Exit Sub
    End If

'get county name and display it
    z% = GetCountyNameFromNumber(county_name, datafields(0) Mod 1000)
    ACSAtlas1(0).Text = Left$(county_name, InStr(county_name, Chr$(0)) - 1)

'get longitude information and display it
    If datafields(2) >= 0 Then
        e_w = "w"
    Else
        e_w = "e"
    End If

    temp = Abs(datafields(2))
    LongDeg = Int(temp / 3600)
    LongMin = (temp / 3600 - LongDeg) * 60

    ACSAtlas1(1).Text = LongDeg & e_w & Format$(LongMin, "00")

'get latitude information and display it
    If datafields(1) >= 0 Then
        n_s = "n"
    Else
        n_s = "s"
    End If

    temp = Abs(datafields(1))
    LatDeg = Int(temp / 3600)
    LatMin = (temp / 3600 - LatDeg) * 60

    ACSAtlas1(2).Text = LatDeg & n_s & Format$(LatMin, "00")

'set time to 12:00 if it is blank or in the incorrect format
    If ACSAtlas1(4).Text = "" Or Len(ACSAtlas1(4).Text) > 5 Then
        ACSAtlas1(4).Text = "12:00"
    End If

'get date information
    M = Month(ACSAtlas1(3).Text)
    D = Day(ACSAtlas1(3).Text)
    Y = Year(ACSAtlas1(3).Text)

    z1% = InStr(ACSAtlas1(4).Text, ":")
    z2% = InStr(ACSAtlas1(4).Text, ".")

'get time information
    If (z1% > 0 Xor z2% > 0) Then
        If z1% > 0 Then
            H = Left$(ACSAtlas1(4).Text, z1% - 1)
            min = Mid$(ACSAtlas1(4).Text, z1% + 1, 2)
        Else
            H = Left$(ACSAtlas1(4).Text, z2% - 1)
            min = Mid$(ACSAtlas1(4).Text, z2% + 1, 2)
        End If
    Else
        ACSAtlas1(4).Text = "12:00"
        H = 12
        min = 0
    End If

    zonename = Space(7)

'look up time zone information
    date_of_change = (Y * 624000) + (M * 48000) + (D * CDbl(1500)) + (H * 60) + min

    Ret& = ACStimechangelookup(M, D, Y, H, min, datafields(4), datafields(3), tzout(0), ttout(0), flagout(0), zonename)     'step 1
    If Ret& <> 0 Then
        If Ret& = -1 Then
            t$ = "Invalid table number (zone or type)"
        ElseIf Ret& = -5 Then
            t$ = "Atlas time table data file not found/not read"
        End If

        MsgBox t$, vbCritical, "Error"
        Exit Sub
    End If

    If ttout(0) = 0 Then
        time_type$ = "Standard Time"
    ElseIf ttout(0) = 1 Then
        time_type$ = "Daylight Saving Time"
    ElseIf ttout(0) = 2 Then
        time_type$ = "War Time"
    ElseIf ttout(0) = 3 Then
        time_type$ = "Double Summer Time"
    ElseIf ttout(0) = 4 Then
        time_type$ = "Local Mean Time"
    ElseIf ttout(0) = 5 Then
        time_type$ = "Half Hour Daylight Saving"
    ElseIf ttout(0) = 6 Then
        time_type$ = "20 minute Daylight Saving"
    ElseIf ttout(0) = 7 Then
        time_type$ = "40 minute Daylight Saving"
    End If

    If ttout(0) = 4 Then
        X! = (LongDeg + (LongMin / 60)) / 15
        't$ = time_type$ & crlf & x! & crlf
    Else
        X! = tzout(0) / 900
        't$ = time_type$ & crlf
    End If

    If ttout(0) = 0 Then
        adj_x! = X!
    ElseIf ttout(0) = 1 Or ttout(0) = 2 Then
        adj_x! = X! - 1
    ElseIf ttout(0) = 3 Then
        adj_x! = X! - 2
    ElseIf ttout(0) = 4 Then
        adj_x! = X!
    End If

    ACSAtlas1(5).Text = time_type$
    ACSAtlas1(6).Text = adj_x!
End Sub

Public Sub ConvertLongLat(long_lat As Long, t$)
'convert longitude and latitude (long_lat) given in seconds to degrees and minutes
    Dim deg As Double, min As Double

    deg = long_lat / 3600
    min = (deg - Fix(deg)) * 60

    t$ = Format(Fix(deg), "##0") & "d " & Format(min, "##0") & "m"
End Sub

Public Sub QuickSort_MultipleDim(sarray() As String, array2() As String, inLow As Long, inHi As Long)
'ascending sort of two separate, but related single-dimension string arrays
    Dim tmpSwap As String, tmpSwap2 As String, tmpLow As Long, tmpHi As Long, X%
    Dim pivot As String

    tmpLow = inLow
    tmpHi = inHi

    pivot = sarray((inLow + inHi) / 2)

    While (tmpLow <= tmpHi)
        While (sarray(tmpLow) < pivot And tmpLow < inHi)
            tmpLow = tmpLow + 1
        Wend

        While (pivot < sarray(tmpHi) And tmpHi > inLow)
            tmpHi = tmpHi - 1
        Wend

        If (tmpLow <= tmpHi) Then
            tmpSwap = sarray(tmpLow)
            sarray(tmpLow) = sarray(tmpHi)
            sarray(tmpHi) = tmpSwap

            tmpSwap2 = array2(tmpLow)
            array2(tmpLow) = array2(tmpHi)
            array2(tmpHi) = tmpSwap2

            tmpLow = tmpLow + 1
            tmpHi = tmpHi - 1
        End If
    Wend

    If (inLow < tmpHi) Then QuickSort_MultipleDim sarray(), array2(), inLow, tmpHi
    If (tmpLow < inHi) Then QuickSort_MultipleDim sarray(), array2(), tmpLow, inHi
End Sub

Private Sub ACSAtlas1_GotFocus(Index As Integer)
    ACSAtlas1(Index).SelStart = 0
    ACSAtlas1(Index).SelLength = Len(ACSAtlas1(Index))
End Sub

Private Sub ACSAtlas1_LostFocus(Index As Integer)
    If Index = 3 Or Index = 4 Then
        'update time zone info if user changes the date or time
        Call Display_associated_data_for_this_city(CInt(index_into_atlas_cities&))
    End If
End Sub

Private Sub cmdLookup_Click()
    Dim deg As Double, min As Double
    Dim long_deg%, long_min%
    Dim lat_deg%, lat_min%
    Dim e%, w%, N%, s%, X!

    If ACSAtlas1(1).Text = "" Or ACSAtlas1(2).Text = "" Then Exit Sub
    
    e% = InStr(ACSAtlas1(1).Text, "e")
    w% = InStr(ACSAtlas1(1).Text, "w")

    If e% > 0 Then
        long_deg% = Left$(ACSAtlas1(1).Text, e% - 1)
        long_min% = Mid$(ACSAtlas1(1).Text, e% + 1)
        InputD!optEast.value = True
    Else
        long_deg% = Left$(ACSAtlas1(1).Text, w% - 1)
        long_min% = Mid$(ACSAtlas1(1).Text, w% + 1)
        InputD!optWest.value = True
    End If

    If long_min% = 60 Then
        long_min% = 0
        long_deg% = long_deg% + 1
    End If

    InputD!txtLongDeg.Text = long_deg%
    InputD!txtLongMin.Text = long_min%


    N% = InStr(ACSAtlas1(2).Text, "n")
    s% = InStr(ACSAtlas1(2).Text, "s")

    If N% > 0 Then
        lat_deg% = Left$(ACSAtlas1(2).Text, N% - 1)
        lat_min% = Mid$(ACSAtlas1(2).Text, N% + 1)
        InputD!optNorth.value = True
    Else
        lat_deg% = Left$(ACSAtlas1(2).Text, s% - 1)
        lat_min% = Mid$(ACSAtlas1(2).Text, s% + 1)
        InputD!optSouth.value = True
    End If

    If lat_min% = 60 Then
        lat_min% = 0
        lat_deg% = lat_deg% + 1
    End If

    InputD!txtLatDeg.Text = lat_deg%
    InputD!txtLatMin.Text = lat_min%

    If ACSAtlas1(5).Text = "Local Mean Time" And InputD!optEast.value = True Then
        InputD!txtTZ.Text = "-" & ACSAtlas1(6).Text
    Else
        InputD!txtTZ.Text = ACSAtlas1(6).Text
    End If

    If Label1(1).Caption = "City" Then
        Unload ACS_Atlas
    End If
End Sub

Private Sub ComboCity_Click()
    Call Analyze_this_city(1)
End Sub

Private Sub ComboCity_LostFocus()
    'to keep the city from going back to the first duplicate city in the list when the user changes the focus
    If Label1(1).Caption = "Dup. city" Then
        Call Analyze_this_city(1)
    Else
        Call Analyze_this_city(0)
    End If
End Sub

Private Sub ComboState_Country_Click()
    Call Analyze_this_state_country
End Sub

Private Sub ComboState_Country_LostFocus()
    Call Analyze_this_state_country
End Sub

Private Sub Form_Load()
    Dim hr%, X&

    crlf = Chr$(13) & Chr$(10)

    Me.Left = 0

    Me.Top = InputD.Top + InputD.Height

'Use this routine to specify how to handle Illinois times in the Standard Time Law periods.
'0 - Always return Standard Time when the law was in effect (default).
'non-zero - Return clock time for Illinois even when the Standard Time Law was in effect.
    atlas_present% = 0
    On Error GoTo no_findcity_dll
    Call SetIllinoisTreatment(1)
    On Error GoTo 0
    
    atlas_present% = 1

'This routine says whether the FindCity routine is to return country names as abbreviations or full names.
'0 - full names (default),   non-zero - abbreviations.
    Call SetReturnAbbreviations(0)

'the reason it is -1 below is that the last entry for the country is "Personal Atlas"
    country_count& = GetCountryCount - 1

    ReDim countries(country_count& - 1), abbrevs(country_count& - 1)

    For X& = 0 To country_count& - 1
        'ret& returns the length of the country name, ret& = 0 means there was an error
        Ret& = GetCountryAtIndex(country_name, country_abbrev, X&)
        If Ret& > 0 Then
            countries(X&) = Left$(country_name, InStr(country_name, Chr$(0)) - 1)
            abbrevs(X&) = Left$(country_abbrev, InStr(country_abbrev, Chr$(0)) - 1)
        End If
    Next X&

'sort the countries() array
    Call QuickSort_MultipleDim(countries, abbrevs, 0, country_count& - 1)

'fill the countries combo box
    Ret& = SendMessage(ComboState_Country.hwnd, WM_SETREDRAW, 0, 0&)

    For X& = 0 To country_count& - 1
        ComboState_Country.AddItem countries(X&)
    Next X&

    Ret& = SendMessage(ComboState_Country.hwnd, WM_SETREDRAW, -1, 0&)

    ACSAtlas1(3).Text = InputD!txtMonth.Text & "/" & InputD!txtDay.Text & "/" & InputD!txtYear.Text

    hr% = InputD!txtBirthHour.Text
    If InputD!optAM.value = True Then
        If hr% = 12 Then
            hr% = 0
        End If
    Else
        If hr% < 12 Then
            hr% = hr% + 12
        End If
    End If

    ACSAtlas1(4).Text = hr% & ":" & InputD!txtBirthMinute.Text

    Exit Sub
    
no_findcity_dll:
    atlas_present% = 0
    MsgBox "I cannot find the file named FindCity.dll", vbCritical, "Missing file"
    Exit Sub
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set ACS_Atlas = Nothing
End Sub

Public Sub Check_if_this_city_has_a_duplicate(Ret&)
    If Ret& >= 1 Then
        Label1(1).Caption = "Dup. city"
        Label1(1).ForeColor = RGB(255, 0, 0)
        Label1(1).FontBold = True
    Else
        Label1(1).Caption = "City"
        Label1(1).ForeColor = RGB(0, 0, 0)
        Label1(1).FontBold = False
    End If
End Sub

Public Sub Analyze_this_city(enter_click%)
'lostfocus_click% = 0 came from lostfocus so it was
    Dim t$, X&

    If enter_click% = 0 Then
        'find the index of the city selected and set that as the city name
        index_into_atlas_cities& = -1
        For X& = 0 To city_count& - 1
            t$ = UCase$(ComboCity.Text)
            If t$ = UCase$(cities(X&)) Then
                Exit For
            End If
        Next X&

        If X& < city_count& Then
            index_into_atlas_cities& = X&
            ComboCity.Text = cities(X&)
        End If
    Else
        index_into_atlas_cities& = ComboCity.ListIndex
    End If

'determine if this city has duplicates in this state
    If ComboCity.Text = "" Then Exit Sub

    Ret& = GetCityAtIndex(ComboCity.Text, index_into_atlas_cities&, "")
    If Ret& = -1 Then
        MsgBox "Current country not set", vbCritical, "Error"
    ElseIf Ret& = -2 Then
        MsgBox "City number out of range", vbCritical, "Error"
    Else
        'take this city's index and display all its attributes
        Call Check_if_this_city_has_a_duplicate(Ret&)
        Call Display_associated_data_for_this_city(CInt(index_into_atlas_cities&))
    End If
End Sub

Public Sub Analyze_this_state_country()
    Dim t$, X&

'reset city, county, and all other associated data
    ComboCity.Text = ""
    ComboCity.Clear
    Call Clear_output_data_due_to_error

'find the index of the country selected and set that as the country name
    index_into_atlas_countries& = -1
    For X& = 0 To country_count& - 1
        t$ = UCase$(ComboState_Country.Text)
        If t$ = UCase$(countries(X&)) Or t$ = UCase$(abbrevs(X&)) Then
            Exit For
        End If
    Next X&

    If X& < country_count& Then
        Ret& = SetCountryByName(countries(X&))
        If Ret& = -1 Then
            MsgBox "Current country is NOT set", vbCritical, "Error"
            Exit Sub
        Else
            index_into_atlas_countries& = Ret&
            ComboState_Country.Text = countries(X&)
        End If
    Else
        MsgBox "I could not find the country you entered", vbCritical, "Error"
        Exit Sub
    End If

'the reason -1 is subtracted below is that the last entry in the country table array is "Personal Atlas"
    city_count& = GetCityCount - 1

    ReDim cities(city_count& - 1)

'get all the cities in this state/country
    For X& = 0 To city_count& - 1
        Ret& = GetCityAtIndex(city_name, X&, "")
        If Ret& = -1 Then
            MsgBox "Current country not set", vbCritical, "Error"
        ElseIf Ret& = -2 Then
            MsgBox "City number out of range", vbCritical, "Error"
        Else
            'take this city and store it in the cities() array
            cities(X&) = Left$(city_name, InStr(city_name, Chr$(0)) - 1)
        End If
    Next X&

'the cities are already sorted, so fill the cities combo box
    Ret& = SendMessage(ComboCity.hwnd, WM_SETREDRAW, 0, 0&)

    For X& = 0 To city_count& - 1
        ComboCity.AddItem cities(X&)
    Next X&

    Ret& = SendMessage(ComboCity.hwnd, WM_SETREDRAW, -1, 0&)
End Sub

Public Sub Clear_output_data_due_to_error()
'clear most of the text boxes on the main form (not Date and Time)
    ACSAtlas1(0).Text = ""
    ACSAtlas1(1).Text = ""
    ACSAtlas1(2).Text = ""
    ACSAtlas1(5).Text = ""
    ACSAtlas1(6).Text = ""
End Sub

