Attribute VB_Name = "MODULE2"

Sub HOUSECALC()
    F = NatalTime!: If Int(NatalTime!) = 12 Then F = NatalTime! - 12
    F = (ConvertDMtoDec(F) + NatalTimeZone!) / 24
    If NatalBirthTime$ = "P.M." Then
        F = F + 0.5
    End If
    LO = Abs(NatalLong!)
    LA = Abs(NatalLat!)
    d2$ = NatalD2$
    D = NatalDay%: M = NatalMonth%: y = NatalYear%

    IM = 12 * (y + 4800) + M - 3
    J# = (2 * (IM - Int(IM / 12) * 12) + 7 + 365 * IM) / 12
    J# = Int(J#) + D + Int(IM / 48) - 32083
'    If J# > 2299171 Then
        J# = (J# + Int(IM / 4800) - Int(IM / 1200) + 38)
        jd = J# + F - 0.5
        NatalJD = jd
'    End If
End Sub

Sub PLANETSINHOUSES()
    Dim CorrPlanetsY

    For X = 1 To 12
        For y = 1 To NumberOfPlanets%
            Mid$(NatalPH$, y * 10 - 5, 10) = " HOUSE"
            CorrPlanetsY = Planets(y) + (1 / 36000)
                If X < 12 And HC(X) > HC(X + 1) Then GoTo PIH6
                If X = 12 And HC(X) > HC(1) Then GoTo PIH8
                If CorrPlanetsY >= HC(X) And CorrPlanetsY < HC(X + 1) And X < 12 Then Mid$(NatalPH$, y * 10 - 9, 4) = Mid$(HCX1$, X * 4 - 3, 4): GoTo PIH9
                If CorrPlanetsY >= HC(X) And CorrPlanetsY < HC(1) And X = 12 Then Mid$(NatalPH$, y * 10 - 9, 4) = Mid$(HCX1$, X * 4 - 3, 4)
                GoTo PIH9

PIH6:
                If (CorrPlanetsY >= HC(X) And CorrPlanetsY < 360) Or (CorrPlanetsY < HC(X + 1) And CorrPlanetsY >= 0) Then Mid$(NatalPH$, y * 10 - 9, y * 10 - 6) = Mid$(HCX1$, X * 4 - 3, 4)
                GoTo PIH9

PIH8:
                If (CorrPlanetsY >= HC(X) And CorrPlanetsY < 360) Or (CorrPlanetsY < HC(1) And CorrPlanetsY >= 0) Then Mid$(NatalPH$, y * 10 - 9, y * 10 - 6) = Mid$(HCX1$, X * 4 - 3, 4)
PIH9:
        Next y
    Next X
End Sub

Sub ReadAllData()
    Open DefaultDirectory & "\HCDATA.DAT" For Input As #1
    Ctx = 0
    Do While Not EOF(1)
        Input #1, HCUSPDATA%(Ctx)
        Ctx = Ctx + 1
    Loop
    Close #1

'read RADIUS POSITIONING data into array starting at 0 degrees - 7th house cusp
    Open DefaultDirectory & "\RADIUS.DAT" For Input As #1
    Ctx = 0
    Do While Not EOF(1)
        Input #1, XRADIUSX%(Ctx)
        Ctx = Ctx + 1
    Loop
    Close #1
End Sub

Sub CalculateAstrology()
    Dim X(6) As Double, t1$, y%

    ReDim sort(78), sortpos(78)

    If Vocation!mnuHouseRegiomontanus.Checked = True Then
        HS$ = "R"
    ElseIf Vocation!mnuHouseKoch.Checked = True Then
        HS$ = "K"
    ElseIf Vocation!mnuHouseCampanus.Checked = True Then
        HS$ = "C"
    ElseIf Vocation!mnuHousePorphyry.Checked = True Then
        HS$ = "O"
    ElseIf Vocation!mnuHouseAlcabitus.Checked = True Then
        HS$ = "B"
    ElseIf Vocation!mnuHouseTopocentric.Checked = True Then
        HS$ = "T"
    Else
        HS$ = "P"
    End If

'added 11 Jan 2003 for updating by time increments
        If InUpdate% = 1 Then
            ZN$ = InputD!txtName.Text & " - in update mode"
            NatalMonth% = LastMonth%: NatalDay% = LastDay%: NatalYear% = LastYear%
            F = LastHour! + LastMinute! / 100
            NatalBirthTime$ = "A.M.": If LastAmPm% = 1 Then NatalBirthTime$ = "P.M."
            If MyiDate% = 2 Then
                NatalDate$ = LTrim$(Str$(LastYear%)) + "/" + LTrim$(Str$(LastMonth%)) + "/" + LTrim$(Str$(LastDay%))
            ElseIf MyiDate% = 1 Then
                NatalDate$ = LTrim$(Str$(LastDay%)) + "/" + LTrim$(Str$(LastMonth%)) + "/" + LTrim$(Str$(LastYear%))
            Else
                NatalDate$ = LTrim$(Str$(LastMonth%)) + "/" + LTrim$(Str$(LastDay%)) + "/" + LTrim$(Str$(LastYear%))
            End If
            NatalTime! = F: NatalTimeZone! = LastTZ!: AMorPM$ = NatalBirthTime$

            NatalLong! = LastLongDeg% + LastLongMin% / 100
            If LastLongEW% = 0 Then
                NatalLong! = -NatalLong!
            End If
            If NatalLong! < 0 Then d1$ = "East" Else d1$ = "West"

            NatalLat! = LastLatDeg% + LastLatMin% / 100
            If LastLatNS% = 1 Then
                NatalLat! = -NatalLat!
            End If
            If NatalLat! < 0 Then d2$ = "South" Else d2$ = "North"

            NatalD1$ = d1$: NatalD2$ = d2$
        Else
            InputErrorFlag% = 0
            Call CheckInputErrors
            Call CheckLatitudeErrors
            Call CheckOverflowErrorsNatal
            If InputErrorFlag% = 1 Then Exit Sub

            Call FetchNatalData
            ZN$ = InputD!txtName.Text
        End If

        Screen.MousePointer = 11
        InputD.Hide: Names.Hide: Geograph.Hide

        ReDim Wheels1Captions$(7), Wheels2Captions$(7)

        Call HOUSECALC

'added 11 Jan 2003 for updating by time increments
        If InUpdate% = 0 Then
            iday% = NatalDay%
            imonth% = NatalMonth%
            iyear% = NatalYear%

            ihour! = Val(InputD!txtBirthHour.Text)
            If InputD!optAM.value = True Then
                If Fix(ihour!) = 12 Then
                    ihour! = ihour! - 12
                End If
            Else
                If Fix(ihour!) <> 12 Then
                    ihour! = ihour! + 12
                End If
            End If
            ihour! = ihour! + NatalTimeZone!
            imin! = Val(InputD!txtBirthMinute.Text)

            lon = Val(InputD!txtLongDeg.Text) + (Val(InputD!txtLongMin.Text) / 60)
            lat = Val(InputD!txtLatDeg.Text) + (Val(InputD!txtLatMin.Text) / 60)

            If UCase$(NatalD1$) = "WEST" Then
                lon = -lon
            End If

            If UCase$(NatalD2$) = "SOUTH" Then
                lat = -lat
            End If
        Else
            iday% = LastDay%
            imonth% = LastMonth%
            iyear% = LastYear%

            ihour! = LastHour!
            If LastAmPm% = 0 Then
                If Fix(ihour!) = 12 Then
                    ihour! = ihour! - 12
                End If
            Else
                If Fix(ihour!) <> 12 Then
                    ihour! = ihour! + 12
                End If
            End If
            ihour! = ihour! + LastTZ!
            imin! = LastMinute!

            If UCase$(NatalD1$) = "EAST" Then
                lon = LastLongDeg% + LastLongMin% / 60
            Else
                lon = -(LastLongDeg% + LastLongMin% / 60)
            End If

            If UCase$(NatalD2$) = "NORTH" Then
                lat = LastLatDeg% + LastLatMin% / 60
            Else
                lat = -(LastLatDeg% + LastLatMin% / 60)
            End If
        End If

        Call PlanetEquations:   'does house cusps, too
        NatalST$ = SiderealTime$

        For x1b% = 1 To 13
            NatalHouse(x1b%) = HC(x1b%)
        Next x1b%

        Call PLANETSINHOUSES

        For x1b% = 1 To NumberOfPlanets%
            Natal(x1b%) = Planets(x1b%)
            SpeedOfNatal(x1b%) = SpeedX(x1b%)
        Next x1b%

        NatalH$ = Retrograde$

'get certain midpoints
    sun_moon_mp = Find_Midpoint(Natal(1), Natal(10))
    jupiter_pluto_mp = Find_Midpoint(Natal(5), Natal(9))

    Vocation!mnuData.Visible = True
    Vocation!mnuWheelsSingleNatal.Visible = True
    Vocation!mnuDataMeaningsNatal.Visible = True
    Vocation!mnuReportNatal.Visible = True
    Vocation!mnuInputData.Visible = True

    Call ClearOutputForm
    
'added
    Buffer = "---------------------------------------------------------------------------------"
    Call PrintBuffer
    
    Call NatalDataList
    
    Call LineFeed
    
    Call Find_MC_sign_and_ruler
    
    Call Find_MC_ruler_aspects_to_natal_planets
    
    Call Find_interception_in_10th_house
    
    Call Planets_conjunct_the_MC
    
    Call Find_MC_aspects_to_natal_planets
    
    Call Find_final_dispositors
    
    Call Planets_in_mutual_reception
    
    Call Find_oriental_planet
    
    Call Find_quintiles
    
    Call Find_quindeciles
    
    Call Find_peregrination
    
    Call Find_Moons_house
    
    Call Find_planets_at_the_Aries_Point
    
    Call Find_stelliums
    
    Call Find_hits_to_Sun_Moon_midpoint
    
    Call Find_hits_to_Jupiter_Pluto_midpoint
    
    For y% = 1 To 10
        Buffer = Space(2) & Find_all_dispositors(y%)
        Call PrintBuffer
    Next y%
    
    Call LineFeed
    
    Call Find_AP_hits_to_natal_midpoints
    
    Call Find_MC_hits_to_natal_midpoints

    Call Find_Mercury_hits_to_natal_midpoints
    
    Buffer = "---------------------------------------------------------------------------------"
    Call PrintBuffer
    
    Call Get_natal_aspects

    Buffer = "---------------------------------------------------------------------------------"
    Call PrintBuffer
'end of addition

    Call NatalList

    For x1b% = 1 To NumberOfPlanets%
        Planets(x1b%) = Natal(x1b%)
    Next x1b%

'    Call Get_natal_aspects

    Call HoraryBasics

    Call AdjustForm

'display the wheel
    Call NatalCaptions

    CurrentOrbsFile$ = DefaultDirectory$ & "\NATAL.ORB"

    For y% = 1 To 13
        HC(y%) = NatalHouse(y%)
    Next y%

    For y% = 1 To NumberOfPlanets%
        Planets(y%) = Natal(y%)
    Next y%

    Retrograde$ = NatalH$

    ax1$ = NatalDate$: SiderealTime$ = NatalST$

    LO = NatalLong!: LA = NatalLat!: d1$ = NatalD1$: d2$ = NatalD2$

    Unload Wheels: Wheels.Show

    OutputD1.SetFocus
    
    Screen.MousePointer = 0
End Sub

Public Function Find_Midpoint(p1x As Double, p2x As Double)
'29 June 2007 bug fix - diff1 and diff2 added (as type SINGLE) to correct for rounding errors
'when Sun or Earth is involved in a midpoint calculation. Sometimes because of rounding errors
'the midpoint position is 180 deg away from what it should be. This causes havoc with the aspectarians.
    Dim mp_pos As Double
    Dim diff1 As Single, diff2 As Single

    mp_pos = (p1x + p2x) / 2

'this finds the nearer midpoint, which may not be what is optimum
    diff1 = mp_pos - p1x
    diff2 = mp_pos - p2x

    'If Abs(mp_pos - p1x) > 90 Or Abs(mp_pos - p2x) > 90 Then
    If Abs(diff1) > 90 Or Abs(diff2) > 90 Then
        mp_pos = mp_pos + 180
    End If

    If mp_pos >= 360 Then mp_pos = mp_pos - 360

    Find_Midpoint = mp_pos
End Function

Sub PlanetEquations()
    Dim d1 As Double, d2 As Double, d3 As Double, t$, w%, y%, z%
    Dim X(6) As Double
    Dim cusp(13) As Double
    Dim ascmc(10) As Double
    Dim cal As Byte

    H = ihour! + imin! / 60#

 ' the next two functions do the same job, converting a calendar date
 ' into a Julian day number
 ' swe_date_conversion() checks for legal dates while swe_julday() handles
 ' even illegal things like 45 Januar etc.
    cal = 103  ' g for gregorian calendar

    tjd_ut = swe_julday(iyear%, imonth%, iday%, H, 1)
    retval = swe_date_conversion(iyear, imonth, iday, H, cal, tjd_ut)

    tjd_et = tjd_ut + swe_deltat(tjd_ut)

    For y% = 0 To 10
        If y% = 0 Then
            z% = 1                      'Sun
        ElseIf y% = 1 Then
            z% = 10                    'Moon
        ElseIf y% = 10 Then
            z% = 11                    'Mean Node
        Else
            z% = y%                   'the rest
        End If

        iflag = 258                     'for geo
        serr$ = String(255, 0)
        plnam$ = String(20, 0)

        ret_flag = swe_calc(tjd_et, y%, iflag, X(0), serr$)

        Planets(z%) = X(0)
        SpeedX(z%) = X(3)
    Next y%

use_porphyry:
    t$ = HS$

    ret_flag = swe_houses(tjd_ut, lat, lon, Asc(t$), cusp(0), ascmc(0))         'tropical

    SidTime = ascmc(2)                  'get sidereal time for later conversion
    Call ConverttoSiderealTime

    
    If HS$ = "T" Then
        'ret_flag = -1 when using Placidus or Koch houses and the latitude is greater than 66 deg
        'maybe I just shouldn't use topocentric, since Porphyry is substituted when needed
        'some error detection has to be included here because topocentric calculations sometimes fail (Barbro Nilsen chart)
        'house 2 is before house 1
        For w% = 2 To 7
            d2 = cusp(w% + 1)
            d1 = cusp(w%)
            d3 = d2 - d1
            
            If d3 < 0 And d3 > -180 Then
                MsgBox "I am switching to Porphyry houses.", vbInformation, "Changing house systems"
                
                HS$ = "O"
                
                GoTo use_porphyry
            End If
        Next w%
        'Beep
    End If
    
    
    For y% = 1 To 12
        HC3(y%) = cusp(y%)
    Next y%

    For y% = 1 To 9
        HC(y% + 3) = HC3(y%)
    Next y%

    For y% = 10 To 12
        HC(y% - 9) = HC3(y%)
    Next y%

    Planets(NumberOfPlanets% - 1) = HC(4)
    Planets(NumberOfPlanets%) = HC(1)

    Retrograde$ = Space$(NumberOfPlanets%)

    For y% = 1 To NumberOfPlanets% - 2
        If SpeedX(y%) < 0 Then Mid$(Retrograde$, y%, 1) = "R"
    Next y%
End Sub


Public Sub ConverttoSiderealTime()
    Dim X

    X = SidTime / 15

    SiderealTime$ = Format$(Int(X), "00") & "h "

    X = (X - Int(X)) * 60

    SiderealTime$ = SiderealTime$ & Format$(Int(X), "00") & "m "

    X = Int((X - Int(X)) * 60)

    SiderealTime$ = SiderealTime$ & Format$(X, "00") & "s"
End Sub
