Attribute VB_Name = "vocation_sr"

Public Sub Find_final_dispositors()
    Dim temp As Integer, X As Integer
    Dim pflag As Boolean
    
    pflag = False
    For X = 1 To 10
        temp = Int(Natal(X) / 30) + 1

        If temp = 1 And X = xSE_MARS Then
            Buffer = Space(2) & "Mars is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        ElseIf (temp = 2 Or temp = 7) And X = xSE_VENUS Then
            Buffer = Space(2) & "Venus is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        ElseIf (temp = 3 Or temp = 6) And X = xSE_MERCURY Then
            Buffer = Space(2) & "Mercury is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        ElseIf temp = 4 And X = xSE_MOON Then
            Buffer = Space(2) & "The Moon is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        ElseIf temp = 5 And X = xSE_SUN Then
            Buffer = Space(2) & "The Sun is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        ElseIf temp = 9 And X = xSE_JUPITER Then
            Buffer = Space(2) & "Jupiter is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        ElseIf temp = 10 And X = xSE_SATURN Then
            Buffer = Space(2) & "Saturn is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        ElseIf temp = 11 And X = xSE_URANUS Then
            Buffer = Space(2) & "Uranus is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        ElseIf temp = 12 And X = xSE_NEPTUNE Then
            Buffer = Space(2) & "Neptune is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        ElseIf temp = 8 And X = xSE_PLUTO Then
            Buffer = Space(2) & "Pluto is in its own sign and is a final dispositor."
            Call PrintBuffer
            pflag = True
        End If
    Next X

    If pflag = True Then
        Call LineFeed
    End If
End Sub

Public Sub Find_MC_sign_and_ruler()
    Dim t$, temp As Integer

    temp = Int(HC(1) / 30) + 1
    
    Buffer = Space(2) & sign_names$(temp) & " is the sign on the MC and its ruler is "
    
    If temp = 1 Then
        t$ = "Mars"
        MC_ruler_pnum% = 4
    ElseIf temp = 2 Then
        t$ = "Venus"
        MC_ruler_pnum% = 3
    ElseIf temp = 3 Then
        t$ = "Mercury"
        MC_ruler_pnum% = 2
    ElseIf temp = 4 Then
        t$ = "Moon"
        MC_ruler_pnum% = 10
    ElseIf temp = 5 Then
        t$ = "Sun"
        MC_ruler_pnum% = 1
    ElseIf temp = 6 Then
        t$ = "Mercury"
        MC_ruler_pnum% = 2
    ElseIf temp = 7 Then
        t$ = "Venus"
        MC_ruler_pnum% = 3
    ElseIf temp = 8 Then
        t$ = "Pluto"
        MC_ruler_pnum% = 9
    ElseIf temp = 9 Then
        t$ = "Jupiter"
        MC_ruler_pnum% = 5
    ElseIf temp = 10 Then
        t$ = "Saturn"
        MC_ruler_pnum% = 6
    ElseIf temp = 11 Then
        t$ = "Uranus"
        MC_ruler_pnum% = 7
    ElseIf temp = 12 Then
        t$ = "Neptune"
        MC_ruler_pnum% = 8
    End If
    
    Buffer = Buffer & t$
    Call PrintBuffer
    
    If temp = 3 Or temp = 12 Or temp = 9 Then
        Buffer = Space(2) & "(possibly more than 1 vocation indicated)"
        Call PrintBuffer
    End If
    
    Call LineFeed
End Sub

Public Sub Find_MC_ruler_aspects_to_natal_planets()
    Dim mp As Double, X As Integer, Y As Integer
    Dim DA As Double, orb As Single, peregrine As Boolean
    Dim pflag As Boolean
    
    Call Get_Tyl_Natal_Orbs
    
    pflag = False
    For Y = 1 To 10
        If Y <> MC_ruler_pnum% Then
            DA = Abs(Natal(MC_ruler_pnum%) - Natal(Y))
            If DA > 180 Then DA = 360 - DA
                
            If DA <= tyl_natal_orbs!(1) Then
                Buffer = Space(2) & PN$(MC_ruler_pnum%) & " is conjunct " & PN$(Y) & "."
                Call PrintBuffer
                pflag = True
            ElseIf DA <= (60 + tyl_natal_orbs!(2)) And DA >= (60 - tyl_natal_orbs!(2)) Then
                Buffer = Space(2) & PN$(MC_ruler_pnum%) & " sextiles " & PN$(Y) & "."
                Call PrintBuffer
                pflag = True
            ElseIf DA <= (90 + tyl_natal_orbs!(3)) And DA >= (90 - tyl_natal_orbs!(3)) Then
                Buffer = Space(2) & PN$(MC_ruler_pnum%) & " squares " & PN$(Y) & "."
                Call PrintBuffer
                pflag = True
            ElseIf DA <= (120 + tyl_natal_orbs!(4)) And DA >= (120 - tyl_natal_orbs!(4)) Then
                Buffer = Space(2) & PN$(MC_ruler_pnum%) & " trines " & PN$(Y) & "."
                Call PrintBuffer
                pflag = True
            ElseIf DA >= 180 - tyl_natal_orbs!(5) Then
                Buffer = Space(2) & PN$(MC_ruler_pnum%) & " opposes " & PN$(Y) & "."
                Call PrintBuffer
                pflag = True
            End If
        End If
    Next Y

    If pflag = True Then
        Call LineFeed
    End If
End Sub


Public Sub Planets_conjunct_the_MC()
    Dim X As Integer
    Dim DA As Double, orb As Single
    Dim pflag As Boolean
    
    orb = 5
    
    pflag = False
    For X = 1 To 10
        DA = Abs(Natal(X) - HC(1))
        If DA > 180 Then DA = 360 - DA
                
        If DA <= orb Then
            Buffer = Space(2) & PN$(X) & " is prominent because it is conjunct the MC."
            Call PrintBuffer
            
            'pflag = True
            
            Call LineFeed
            
            MC_ruler_pnum% = X
            Call Find_MC_ruler_aspects_to_natal_planets
        End If
    Next X

    If pflag = True Then
        Call LineFeed
    End If
End Sub

Public Sub Planets_in_mutual_reception()
    Dim temp As Integer, q As Integer, X As Integer, Y As Integer
    Dim pflag As Boolean
    
'find any planets in mutual reception by sign
    pflag = False
    For Y = 1 To 10
        temp = Int(Natal(Y) / 30) + 1
            
        If temp = 1 Then X = 4
        If temp = 2 Or temp = 7 Then X = 3
        If temp = 3 Or temp = 6 Then X = 2
        If temp = 4 Then X = 10
        If temp = 5 Then X = 1
        If temp = 8 Then X = 9
        If temp = 9 Then X = 5
        If temp = 10 Then X = 6
        If temp = 11 Then X = 7
        If temp = 12 Then X = 8

        temp = Int(Natal(X) / 30) + 1
            
        If Y = 1 And X > Y And temp = 5 Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
        If Y = 10 And X > Y And temp = 4 Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
        If Y = 2 And X > Y And (temp = 3 Or temp = 6) Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
        If Y = 3 And X > Y And (temp = 2 Or temp = 7) Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
        If Y = 4 And X > Y And temp = 1 Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
        If Y = 5 And X > Y And temp = 9 Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
        If Y = 6 And X > Y And temp = 10 Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
        If Y = 7 And X > Y And temp = 11 Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
        If Y = 8 And X > Y And temp = 12 Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
        If Y = 9 And X > Y And temp = 8 Then Buffer = Space(2) & PN$(Y) & " is in mutual reception with " & PN$(X): GoSub check_for_aspect
    Next Y
    
    If pflag = True Then
        Call LineFeed
    End If
    
    Exit Sub

check_for_aspect:
    q = Are_these_planets_aspecting_each_other(Y, X)
    If q > 0 Then
        Buffer = Buffer & " - these planets are in aspect (" & q & ")."
    Else
        Buffer = Buffer & " - no aspect between them."
    End If
    
    Call PrintBuffer
    pflag = True
    
    Return
End Sub

Public Sub Find_oriental_planet()
    Dim sort() As Double, sortpos() As Integer, temp As Double, temp1 As Integer, X As Integer, Y As Integer
    Dim pflag As Boolean
    
    ReDim sort(11), sortpos(11)
    
    pflag = False
    For X = 1 To 10
        sort(X) = Natal(X)
        sortpos(X) = X
    Next X

    For X = 1 To 9
        For Y = X + 1 To 10
            If sort(Y) > sort(X) Then
                temp = sort(X): temp1 = sortpos(X)
                sort(X) = sort(Y): sortpos(X) = sortpos(Y)
                sort(Y) = temp: sortpos(Y) = temp1
            End If
        Next Y
    Next X
    
    sort(11) = sort(1)
    sortpos(11) = sortpos(1)

    For X = 1 To 10
        If sortpos(X) = 1 Then
            Buffer = Space(2) & PN$(sortpos(X + 1)) & " is the oriental planet."
            Call PrintBuffer
            pflag = True
            Exit For
        End If
    Next X
    
    If pflag = True Then
        Call LineFeed
    End If
End Sub

Public Sub Find_stelliums()
'count the number of planets in each house
    Dim nopih() As Integer, temp As Integer, X As Integer
    Dim pflag As Boolean
    
    ReDim nopih(12)
    
    pflag = False
    
    For X = 1 To 10
        temp = Val(Mid$(NatalPH$, X * 10 - 9, 2))
        nopih(temp) = nopih(temp) + 1
    Next X
    
    For X = 1 To 12
        If nopih(X) >= 4 Then
            Buffer = Space(2) & "House " & X & " contains a stellium of planets."
            Call PrintBuffer
            pflag = True
        End If
    Next X

    If pflag = True Then
        Call LineFeed
    End If
End Sub

Public Sub Find_quintiles()
    Dim X As Integer, Y As Integer
    Dim DA As Double, orb As Single
    Dim pflag As Boolean
    
    orb = 2.5
    
    pflag = False
    For Y = 1 To NumberOfPlanets% - 1
        For X = Y + 1 To NumberOfPlanets%
            DA = Abs(Natal(Y) - Natal(X))
            If DA > 180 Then DA = 360 - DA
                
            If DA <= (72 + orb) And DA >= (72 - orb) Then
                Buffer = Space(2) & PN$(Y) & " is quintile " & PN$(X)
                Call PrintBuffer
                pflag = True
            End If
        Next X
    Next Y

    If pflag = True Then
        Call LineFeed
    End If
End Sub

Public Sub Find_quindeciles()
    Dim X As Integer, Y As Integer
    Dim DA As Double, orb As Single
    Dim pflag As Boolean
    
    orb = 2.5
    
    pflag = False
    For Y = 1 To NumberOfPlanets% - 1
        For X = Y + 1 To NumberOfPlanets%
            DA = Abs(Natal(Y) - Natal(X))
            If DA > 180 Then DA = 360 - DA
                
            If DA <= (165 + orb) And DA >= (165 - orb) Then
                Buffer = Space(2) & PN$(Y) & " is quindecile " & PN$(X)
                Call PrintBuffer
                pflag = True
            End If
        Next X
    Next Y

    If pflag = True Then
        Call LineFeed
    End If
End Sub


Public Sub Find_peregrination()
    Dim X As Integer, Y As Integer
    Dim DA As Double, peregrine As Boolean
    Dim pflag As Boolean
    
    Call Get_Tyl_Natal_Orbs
    
    pflag = False
    For Y = 1 To 10
        peregrine = True
        For X = 1 To 10
            If X <> Y Then
                DA = Abs(Natal(Y) - Natal(X))
                If DA > 180 Then DA = 360 - DA
                
                If DA <= tyl_natal_orbs!(1) Then
                    peregrine = False
                ElseIf DA <= (60 + tyl_natal_orbs!(2)) And DA >= (60 - tyl_natal_orbs!(2)) Then
                    peregrine = False
                ElseIf DA <= (90 + tyl_natal_orbs!(3)) And DA >= (90 - tyl_natal_orbs!(3)) Then
                    peregrine = False
                ElseIf DA <= (120 + tyl_natal_orbs!(4)) And DA >= (120 - tyl_natal_orbs!(4)) Then
                    peregrine = False
                ElseIf DA >= 180 - tyl_natal_orbs!(5) Then
                    peregrine = False
                End If
            End If
        Next X
        
        If peregrine = True Then
            Buffer = Space(2) & PN$(Y) & " is peregrine."
            Call PrintBuffer
            pflag = True
        End If
    Next Y

    If pflag = True Then
        Call LineFeed
    End If
End Sub

Public Sub Find_planets_at_the_Aries_Point()
    Dim Y As Integer
    Dim pflag As Boolean
    
    pflag = False
    For Y = 1 To NumberOfPlanets%
        If Natal(Y) <= 1.5 Or (Natal(Y) >= 88.5 And Natal(Y) < 91.5) Or _
          (Natal(Y) >= 178.5 And Natal(Y) < 181.5) Or _
          (Natal(Y) >= 268.5 And Natal(Y) < 271.5) Or _
          Natal(Y) >= 358.5 Then
            Buffer = Space(2) & PN$(Y) & " is at the Aries Point."
            Call PrintBuffer
            pflag = True
        End If
    Next Y

    If pflag = True Then
        Call LineFeed
    End If
End Sub

Public Sub Find_hits_to_Sun_Moon_midpoint()
    Dim X As Integer, Y As Integer
    Dim DA As Double, orb As Single, peregrine As Boolean
    Dim pflag As Boolean
    
    orb = 2.5
    
    pflag = False
    For Y = 1 To 12
        If Y <> 1 And Y <> 10 Then
            DA = Abs(Natal(Y) - sun_moon_mp)
            If DA > 180 Then DA = 360 - DA
                
            If DA <= orb Or (DA <= (90 + orb) And DA >= (90 - orb)) Or (DA <= (165 + orb) And DA >= (165 - orb)) Or DA >= 180 - orb Then
                If Y <> 1 And Y <> 10 Then
                    Buffer = Space(2) & PN$(Y) & " is configured with the Sun/Moon midpoint."
                    Call PrintBuffer
                    pflag = True
                End If
            End If
        End If
    Next Y

    If pflag = True Then
        Call LineFeed
    End If
End Sub

Public Sub Find_hits_to_Jupiter_Pluto_midpoint()
    Dim X As Integer, Y As Integer
    Dim DA As Double, orb As Single, peregrine As Boolean
    Dim pflag As Boolean
    
    orb = 2.5
    
    pflag = False
    For Y = 1 To 12
        DA = Abs(Natal(Y) - jupiter_pluto_mp)
        If DA > 180 Then DA = 360 - DA
                
        If DA <= orb Or (DA <= (90 + orb) And DA >= (90 - orb)) Or (DA <= (165 + orb) And DA >= (165 - orb)) Or DA >= 180 - orb Then
            If Y <> 5 And Y <> 9 Then
                Buffer = Space(2) & PN$(Y) & " is configured with the Jupiter/Pluto midpoint."
                Call PrintBuffer
                pflag = True
            End If
        End If
    Next Y

    If pflag = True Then
        Call LineFeed
    End If
End Sub


Public Sub Find_MC_hits_to_natal_midpoints()
    Dim mp As Double, X As Integer, Y As Integer
    Dim DA As Double, orb As Single, peregrine As Boolean
    
    orb = 2.5
    
    For Y = 1 To 11
        For X = Y + 1 To 12
            mp = Find_Midpoint(Natal(Y), Natal(X))
            DA = Abs(HC(1) - mp)
            If DA > 180 Then DA = 360 - DA
                
            If DA <= orb Or (DA <= (90 + orb) And DA >= (90 - orb)) Or (DA <= (165 + orb) And DA >= (165 - orb)) Or DA >= 180 - orb Then
                Buffer = Space(2) & "MC is configured with the " & PN$(Y) & "/" & PN$(X) & " midpoint."
                Call PrintBuffer
            End If
        Next X
    Next Y

    Call LineFeed
End Sub

Public Sub Find_AP_hits_to_natal_midpoints()
    Dim mp As Double, X As Integer, Y As Integer
    Dim DA As Double, orb As Single, peregrine As Boolean
    
    orb = 2.5
    
    For Y = 1 To NumberOfPlanets% - 1
        For X = Y + 1 To NumberOfPlanets%
            mp = Find_Midpoint(Natal(Y), Natal(X))
            DA = Abs(0 - mp)
            If DA > 180 Then DA = 360 - DA
                
            If DA <= orb Or (DA <= (90 + orb) And DA >= (90 - orb)) Or (DA <= (165 + orb) And DA >= (165 - orb)) Or DA >= 180 - orb Then
                Buffer = Space(2) & "AP is configured with the " & PN$(Y) & "/" & PN$(X) & " midpoint."
                Call PrintBuffer
            End If
        Next X
    Next Y

    Call LineFeed
End Sub

Public Sub Find_Mercury_hits_to_natal_midpoints()
    Dim mp As Double, X As Integer, Y As Integer
    Dim DA As Double, orb As Single, peregrine As Boolean
    
    orb = 2.5
    
    For Y = 1 To NumberOfPlanets% - 1
        If Y <> 2 Then
            For X = Y + 1 To NumberOfPlanets%
                If X <> 2 Then
                    mp = Find_Midpoint(Natal(Y), Natal(X))
                    DA = Abs(Natal(2) - mp)
                    If DA > 180 Then DA = 360 - DA
                
                    If DA <= orb Or (DA <= (90 + orb) And DA >= (90 - orb)) Or (DA <= (165 + orb) And DA >= (165 - orb)) Or DA >= 180 - orb Then
                        Buffer = Space(2) & "Mercury is configured with the " & PN$(Y) & "/" & PN$(X) & " midpoint."
                        Call PrintBuffer
                    End If
                End If
            Next X
        End If
    Next Y

    Call LineFeed
End Sub



Public Sub Find_Moons_house()
    Dim temp As Integer

    temp = Int(Natal(10) / 30) + 1
    
    Buffer = Space(2) & "The Moon is in the " & Trim(Mid$(NatalPH$, 10 * 10 - 9, 10)) & " - and in the sign (reigning need) of " & sign_names$(temp) & "."
    Call PrintBuffer
    
    Call LineFeed
End Sub

Public Sub Find_MC_aspects_to_natal_planets()
    Dim mp As Double, X As Integer, Y As Integer
    Dim DA As Double, orb As Single, peregrine As Boolean
    
    Call Get_Tyl_Natal_Orbs
    
    For Y = 1 To 10
        DA = Abs(HC(1) - Natal(Y))
        If DA > 180 Then DA = 360 - DA
                
        If DA <= tyl_natal_orbs!(1) Then
            Buffer = Space(2) & "MC is conjunct " & PN$(Y) & "."
            Call PrintBuffer
        ElseIf DA <= (60 + tyl_natal_orbs!(2)) And DA >= (60 - tyl_natal_orbs!(2)) Then
            Buffer = Space(2) & "MC sextiles " & PN$(Y) & "."
            Call PrintBuffer
        ElseIf DA <= (90 + tyl_natal_orbs!(3)) And DA >= (90 - tyl_natal_orbs!(3)) Then
            Buffer = Space(2) & "MC squares " & PN$(Y) & "."
            Call PrintBuffer
        ElseIf DA <= (120 + tyl_natal_orbs!(4)) And DA >= (120 - tyl_natal_orbs!(4)) Then
            Buffer = Space(2) & "MC trines " & PN$(Y) & "."
            Call PrintBuffer
        ElseIf DA >= 180 - tyl_natal_orbs!(5) Then
            Buffer = Space(2) & "MC opposes " & PN$(Y) & "."
            Call PrintBuffer
        End If
    Next Y

    Call LineFeed
End Sub

Public Function Find_all_dispositors(p1 As Integer) As String
    Dim temp As Integer, X As Integer

    X = p1
    temp = Int(Natal(p1) / 30) + 1

    If temp = 1 Then
        Find_all_dispositors = PN$(p1) & " is disposited by Mars."
    ElseIf (temp = 2 Or temp = 7) Then
        Find_all_dispositors = PN$(p1) & " is disposited by Venus."
    ElseIf (temp = 3 Or temp = 6) Then
        Find_all_dispositors = PN$(p1) & " is disposited by Mercury."
    ElseIf temp = 4 Then
        Find_all_dispositors = PN$(p1) & " is disposited by Moon."
    ElseIf temp = 5 Then
        Find_all_dispositors = PN$(p1) & " is disposited by Sun."
    ElseIf temp = 8 Then
        Find_all_dispositors = PN$(p1) & " is disposited by Pluto."
    ElseIf temp = 9 Then
        Find_all_dispositors = PN$(p1) & " is disposited by Jupiter."
    ElseIf temp = 10 Then
        Find_all_dispositors = PN$(p1) & " is disposited by Saturn."
    ElseIf temp = 11 Then
        Find_all_dispositors = PN$(p1) & " is disposited by Uranus."
    ElseIf temp = 12 Then
        Find_all_dispositors = PN$(p1) & " is disposited by Neptune."
    End If
End Function

Public Sub Find_interception_in_10th_house()
    Dim HC3() As Double, ih%(), t$, temp As Integer
    Dim temp7 As Integer, temp8 As Integer, X As Integer

    ReDim HC3(12), ih%(12)
    
    For X = 10 To 12
        HC3(X) = NatalHouse(X - 9)
    Next X
    
    For X = 1 To 9
        HC3(X) = NatalHouse(X + 3)
    Next X

'get how many signs are intercepted in each house
    For X = 1 To 12
        If X <> 12 Then
            temp7 = Int(HC3(X) / 30) + 1
            temp8 = Int(HC3(X + 1) / 30) + 1
        Else
            temp7 = Int(HC3(12) / 30) + 1
            temp8 = Int(HC3(1) / 30) + 1
        End If
        If temp8 - temp7 < 0 Then temp8 = temp8 + 12
        If temp8 - temp7 = 2 Then
            ih%(X) = temp7 + 1
            If ih%(X) > 12 Then ih%(X) = ih%(X) - 12
        Else
            ih%(X) = 0
        End If
    Next X

'value of ih%(10) is the sign intercepted in the 10th house
    If ih%(10) <> 0 Then
        temp = ih%(10)
        Buffer = Space(2) & sign_names$(temp) & " is intercepted in the 10th house and its ruler is "
    
        If temp = 1 Then
            t$ = "Mars"
            MC_ruler_pnum% = 4
        ElseIf temp = 2 Then
            t$ = "Venus"
            MC_ruler_pnum% = 3
        ElseIf temp = 3 Then
            t$ = "Mercury"
            MC_ruler_pnum% = 2
        ElseIf temp = 4 Then
            t$ = "Moon"
            MC_ruler_pnum% = 10
        ElseIf temp = 5 Then
            t$ = "Sun"
            MC_ruler_pnum% = 1
        ElseIf temp = 6 Then
            t$ = "Mercury"
            MC_ruler_pnum% = 2
        ElseIf temp = 7 Then
            t$ = "Venus"
            MC_ruler_pnum% = 3
        ElseIf temp = 8 Then
            t$ = "Pluto"
            MC_ruler_pnum% = 9
        ElseIf temp = 9 Then
            t$ = "Jupiter"
            MC_ruler_pnum% = 5
        ElseIf temp = 10 Then
            t$ = "Saturn"
            MC_ruler_pnum% = 6
        ElseIf temp = 11 Then
            t$ = "Uranus"
            MC_ruler_pnum% = 7
        ElseIf temp = 12 Then
            t$ = "Neptune"
            MC_ruler_pnum% = 8
        End If
    
        Buffer = Buffer & t$
        Call PrintBuffer
    
        If temp = 3 Or temp = 12 Or temp = 9 Then
            Buffer = Space(2) & "(possibly more than 1 vocation indicated)"
            Call PrintBuffer
        End If
    
        Call LineFeed
        
        Call Find_MC_ruler_aspects_to_natal_planets
    End If
End Sub

Public Function Are_these_planets_aspecting_each_other(p1 As Integer, p2 As Integer) As Integer
    Dim DA As Double, q As Integer
    
    Call Get_Tyl_Natal_Orbs
    
    q = 0
    DA = Abs(Natal(p1) - Natal(p2))
    If DA > 180 Then DA = 360 - DA
                
    If DA <= tyl_natal_orbs!(1) Then
        q = 1
    ElseIf DA <= (60 + tyl_natal_orbs!(2)) And DA >= (60 - tyl_natal_orbs!(2)) Then
        q = 2
    ElseIf DA <= (72 + tyl_natal_orbs!(13)) And DA >= (72 - tyl_natal_orbs!(13)) Then
        q = 13
    ElseIf DA <= (90 + tyl_natal_orbs!(3)) And DA >= (90 - tyl_natal_orbs!(3)) Then
        q = 3
    ElseIf DA <= (120 + tyl_natal_orbs!(4)) And DA >= (120 - tyl_natal_orbs!(4)) Then
        q = 4
    ElseIf DA <= (165 + tyl_natal_orbs!(16)) And DA >= (165 - tyl_natal_orbs!(16)) Then
        q = 16
    ElseIf DA >= 180 - tyl_natal_orbs!(5) Then
        q = 5
    End If
        
    Are_these_planets_aspecting_each_other = q
End Function
