Attribute VB_Name = "Module91"
Global Const REG_SZ = 1                 ' Unicode nul terminated string
Global Const REG_BINARY = 3          ' Free form binary
Global Const HKEY_CURRENT_USER = &H80000001

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

Function RegQueryStringValue(ByVal hKey As Long, ByVal strValueName As String) As String
    Dim lResult As Long, lValueType As Long, strBuf As String, lDataBufSize As Long

'retrieve nformation about the key
    lResult = RegQueryValueEx(hKey, strValueName, 0, lValueType, ByVal 0, lDataBufSize)
    If lResult = 0 Then
        If lValueType = REG_SZ Then
            'Create a buffer
            strBuf = String(lDataBufSize, Chr$(0))
            'retrieve the key's content
            lResult = RegQueryValueEx(hKey, strValueName, 0, 0, ByVal strBuf, lDataBufSize)
            If lResult = 0 Then
                'Remove the unnecessary chr$(0)'s
                RegQueryStringValue = Left$(strBuf, InStr(1, strBuf, Chr$(0)) - 1)
            End If
        ElseIf lValueType = REG_BINARY Then
            Dim strData As Integer
            'retrieve the key's value
            lResult = RegQueryValueEx(hKey, strValueName, 0, 0, strData, lDataBufSize)
            If lResult = 0 Then
                RegQueryStringValue = strData
            End If
        End If
    End If
End Function

Function GetString(hKey As Long, strPath As String, strValue As String)
    Dim Ret

'Open the key
    RegOpenKey hKey, strPath, Ret

'Get the key's content
    GetString = RegQueryStringValue(Ret, strValue)

'Close the key
    RegCloseKey Ret
End Function

Sub INI_GetSettings_WIN_INI()
    Dim t$, Fetch As String
    Dim iflag1%, iflag2%

    MyiDate% = 0: MyiTime% = 0              'set init values
    iflag1% = 0: iflag2% = 0

    Close #1
    On Error GoTo gwis1
    Open "c:\windows\win.ini" For Input As #1

    Do While Not EOF(1)
        Line Input #1, t$

        Fetch = Right$(t$, Len(t$) - InStr(t$, "="))

        If LCase$(Left$(t$, 5)) = "idate" Then
            MyiDate% = Val(Fetch)
            iflag1% = 1
        End If

        If LCase$(Left$(t$, 5)) = "itime" Then
            MyiTime% = Val(Fetch)
            iflag2% = 1
        End If

        Loop
gwis2:
    Close #1
    On Error GoTo 0

    If iflag1% = 0 Then
        Ret = GetString(HKEY_CURRENT_USER, "Control Panel\International", "iDate")
        MyiDate% = Val(Ret)
    End If

    If iflag2% = 0 Then
        Ret = GetString(HKEY_CURRENT_USER, "Control Panel\International", "iTime")
        MyiTime% = Val(Ret)
    End If

    Exit Sub

gwis1:
        Resume gwis2
End Sub

