Attribute VB_Name = "acsatlas_sr"
Option Explicit

Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Integer, ByVal lParam As Long) As Long

Declare Function AddToPersonal Lib "FindCity.dll" Alias "ZAddToPersonalA" (ByVal City As String, cityfields As Long) As Long
Declare Function AddPlaceToPersonal Lib "FindCity.dll" Alias "ZAddPlaceToPersonalA" (ByVal City As String, ByVal County As Long, ByVal Latitude As Long, ByVal Longitude As Long, ByVal typetable As Long, ByVal ZoneTable As Long) As Long
Declare Function DeleteFromPersonalByIndex Lib "FindCity.dll" Alias "ZDeleteFromPersonalByIndex" (ByVal CityNumber As Long) As Long
Declare Function DeleteFromPersonalByName Lib "FindCity.dll" Alias "ZDeleteFromPersonalByNameA" (ByVal cityname As String) As Long

Declare Sub GetRevDate Lib "FindCity.dll" Alias "ZGetRevDateA" (ByVal revdate As String)

Declare Function SetPaths Lib "FindCity.dll" Alias "ZSetPathsA" (ByVal pMainFiles As String, ByVal pPersonal As String) As Long
Declare Sub SetReturnAbbreviations Lib "FindCity.dll" Alias "ZSetReturnAbbreviations" (ByVal bretabbr As Long)
Declare Sub SetDupReturnFlag Lib "FindCity.dll" Alias "ZSetDupReturnFlag" (ByVal dupret As Long)
Declare Sub SetIllinoisTreatment Lib "FindCity.dll" Alias "ZSetIllinoisTreatment" (ByVal IllinoisAction As Long)
Declare Sub SetHalfHourDST Lib "FindCity.dll" Alias "ZSetHalfHourDST" (ByVal HalfDST As Long)
Declare Function VersionNumber Lib "FindCity.dll" Alias "ZVersionNumber" () As Long

Declare Function GetAlternateCount Lib "FindCity.dll" Alias "ZGetAlternateCount" () As Long
Declare Function GetAlternateAtIndex Lib "FindCity.dll" Alias "ZGetAlternateAtIndexA" (ByVal AltName As String, ByVal AltAbbrev As String, ByVal nalt As Long) As Long

Declare Function GetCountryCount Lib "FindCity.dll" Alias "ZGetCountryCount" () As Long
Declare Function GetCountryAtIndex Lib "FindCity.dll" Alias "ZGetCountryAtIndexA" (ByVal countryname As String, ByVal abbreviation As String, ByVal countrynumber As Long) As Long
Declare Function SetCountryByIndex Lib "FindCity.dll" Alias "ZSetCountryByIndex" (ByVal countrynumber As Long) As Long
Declare Function SetCountryByName Lib "FindCity.dll" Alias "ZSetCountryByNameA" (ByVal countryname As String) As Long

Declare Function GetCityCount Lib "FindCity.dll" Alias "ZGetCityCount" () As Long
Declare Function GetCityAtIndex Lib "FindCity.dll" Alias "ZGetCityAtIndexA" (ByVal cityname As String, ByVal CityNumber As Long, ByVal MarkPrimary As String) As Long
'Return codes for above:
'0 City name unique to current country.
'1 Primary duplicate city.
'2 Secondary duplicate city.
Declare Function GetIndexOfCity Lib "FindCity.dll" Alias "ZGetIndexOfCityA" (ByVal cityname As String, lastbefore As Long) As Long
Declare Function GetIndexOfCityInCounty Lib "FindCity.dll" Alias "ZGetIndexOfCityInCountyA" (ByVal cityname As String, ByVal countynumber As Long, lastbefore As Long) As Long
Declare Function FindCity Lib "FindCity.dll" Alias "ZFindCityA" (ByVal Placename As String, ByVal City As String, ByVal County As String, ByVal Country As String, datafields As Long) As Long
Declare Function GetDataFields Lib "FindCity.dll" Alias "ZGetDataFields" (ByVal CityNumber As Long, datafields As Long) As Long
Declare Function GetCityData Lib "FindCity.dll" Alias "ZGetCityData" (ByVal CityNumber As Long, ByVal countydup As Long, ByVal Latitude As Long, ByVal Longitude As Long, ByVal typetable As Long, ByVal ZoneTable As Long, ByVal soc As Long) As Long

Declare Function GetCountyCount Lib "FindCity.dll" Alias "ZGetCountyCount" () As Integer
Declare Function GetCountyNumberFromName Lib "FindCity.dll" Alias "ZGetCountyNumberFromNameA" (ByVal County As String) As Long
Declare Function GetCountyNameFromNumber Lib "FindCity.dll" Alias "ZGetCountyNameFromNumberA" (ByVal County As String, ByVal cn As Long) As Long
Declare Function GetCountyAtIndex Lib "FindCity.dll" Alias "ZGetCountyAtIndexA" (ByVal countyname As String, ByVal cindex As Long) As Integer

Declare Function LookupCity Lib "FindCity.dll" Alias "ZLookupCityA" (ByVal Placename As String, ByVal City As String, ByVal County As String, ByVal Country As String, ByVal countydup As Long, ByVal Latitude As Long, ByVal Longitude As Long, ByVal typetable As Long, ByVal ZoneTable As Long, ByVal soc As Long) As Long

Declare Function ACStimechangelookup Lib "FindCity.dll" Alias "ZACStimechangelookupA" (ByVal Month As Integer, ByVal Day As Integer, ByVal Year As Integer, ByVal Hour As Integer, ByVal Minute As Integer, ByVal TZIn As Integer, ByVal TTIn As Integer, tzout As Integer, ttout As Integer, flagout As Integer, ByVal zonename As String) As Integer

Declare Function GetZoneCount Lib "FindCity.dll" Alias "ZGetZoneCount" () As Long
Declare Function GetZoneNameAtIndex Lib "FindCity.dll" Alias "ZGetZoneNameAtIndexA" (ByVal zonename As String, ByVal zindex As Long) As Long
Declare Sub GetZoneName Lib "FindCity.dll" Alias "ZGetZoneNameA" (ByVal zname As String, ByVal Zone As Long)
Declare Function GetZoneFromName Lib "FindCity.dll" Alias "ZGetZoneFromNameA" (ByVal zonename As String) As Long
Declare Sub GetZoneTypeAbbreviation Lib "FindCity.dll" Alias "ZGetZoneTypeAbbreviationA" (ByVal ztabbr As String, ByVal Zone As Long, ByVal xtype As Long)
Declare Function BuildChangesTable Lib "FindCity.dll" Alias "ZBuildChangesTable" (ByVal TZIn As Long, ByVal TTIn As Long, ByVal endyear As Long, ByVal bGMT As Long, ByVal bExpandUS As Long) As Long
Declare Function MakeChangesTable Lib "FindCity.dll" Alias "ZMakeChangesTable" (ByVal nsoc As Long, ByVal ncity As Long, ByVal endyear As Long, ByVal bGMT As Long, ByVal bExpandUS As Long) As Long
Declare Function GetChangeAtIndex Lib "FindCity.dll" Alias "ZGetChangeAtIndex" (ByVal tcindex As Long, Zone As Long, xtype As Long) As Long
Declare Function SoundexFirstCity Lib "FindCity.dll" Alias "ZSoundexFirstCityA" (ByVal Placename As String, ByVal City As String, ByVal County As String) As Integer
Declare Function SoundexNextCity Lib "FindCity.dll" Alias "ZSoundexNextCityA" (ByVal handle As Integer, ByVal City As String, ByVal County As String) As Integer
Declare Function SoundexClose Lib "FindCity.dll" Alias "ZSoundexClose" (ByVal handle As Integer) As Integer
